<app-page-title [heading]="heading" [subheading]="subheading" [icon]="icon">
  <button (click)="newRow()" class="btn btn-primary">
    <i class="fa fa-plus mr-2"></i>Nuevo
  </button>
  <button class="btn btn-success ml-1" (click)="guardar()" [disabled]="ngForm.invalid">
    <i class="fa fa-save mr-2"></i>Guardar
  </button>
  <button class="btn btn-danger ml-1" [disabled]="!flagEdit" (click)="eliminar()">
    <i class="fas fa-trash-alt mr-2"></i>Eliminar
  </button>
</app-page-title>

<div class="card">
  <div class="card-body">

    <form [formGroup]="ngForm">
      <div class="row">
        <div class="col-4 col-sm-3 col-md-3 col-lg-2 col-xl-2">
          <div class="form-group">
            <label>Extensión</label>
            <input type="tel" pattern="[0-9]*" formControlName="exten" value="" min="0" max="99999"
            class="form-control"
              [readonly]="flagEdit">
          </div>
        </div>
        <div class="col-6 col-sm-5 col-md-5 col-lg-4 col-xl-4">
          <div class="form-group">
            <label>Descripción</label>
            <input type="text" formControlName="Descripcion" class="form-control" maxlength="30">
          </div>
        </div>
        <div class="col-4 col-sm-3 col-md-3 col-lg-2 col-xl-2">
          <label class="w-100">Grupo</label>
          <div class="input-group">
            <input type="tel" pattern="[0-9]*" class="form-control" formControlName="Grupo" readonly>
            <div class="input-group-append">
              <button class="btn btn-info" (click)="openModal(modal, 'telefonosGrupos')">
                <i class="fas fa-search"></i>
              </button>
            </div>
          </div>
        </div>
        <div class="col-4 col-sm-3 col-md-3 col-lg-2 col-xl-2">
          <label class="w-100">Depto.</label>
          <div class="input-group">
            <input type="tel" pattern="[0-9]*" class="form-control" formControlName="Depto" readonly>
            <div class="input-group-append">
              <button class="btn btn-info" (click)="openModal(modal, 'telefonosDepto')">
                <i class="fas fa-search"></i>
              </button>
            </div>
          </div>
        </div>
        <div class="col-4 col-sm-3 col-md-3 col-lg-2 col-xl-2">
          <label class="w-100">Cuarto</label>
          <div class="input-group">
            <input type="tel" pattern="[0-9]*" class="form-control" formControlName="cuarto" readonly>
            <div class="input-group-append">
              <button class="btn btn-info" (click)="openModal(modal, 'allCrts')">
                <i class="fas fa-search"></i>
              </button>
            </div>
          </div>
        </div>
        <div class="col-4 col-sm-3 col-md-3 col-lg-2 col-xl-2">
          <label class="w-100"># Folio</label>
          <div class="input-group">
            <input type="number" class="form-control" formControlName="NoFolio" min="0" max="9999999">
          </div>
        </div>
        <div class="col-4 col-sm-3 col-md-3 col-lg-2 col-xl-2">
          <label class="w-100">Tipo</label>
          <div class="input-group">
            <input type="text" class="form-control" formControlName="Tipo" readonly>
            <div class="input-group-append">
              <button class="btn btn-info" (click)="openModal(modal, 'telefonosTTarifa')">
                <i class="fas fa-search"></i>
              </button>
            </div>
          </div>
        </div>
        <div class="col-4 col-sm-3 col-md-3 col-lg-2 col-xl-2">
          <label class="w-100">Desvío</label>
          <div class="input-group">
            <input type="number" class="form-control" min="0" formControlName="Desviacion" readonly>
            <div class="input-group-append">
              <button class="btn btn-info" (click)="openModal(modal, 'telefonosExt')">
                <i class="fas fa-search"></i>
              </button>
            </div>
          </div>
        </div>
      </div>
    </form>

    <div class="divider"></div>

    <kendo-grid [kendoGridBinding]="dataGrid" [selectable]="true" [filter]="filter" filterable="menu" [navigable]="true"
      [reorderable]="true" [resizable]="true" [sortable]="true" (selectionChange)="selectRow($event)"
      [pageSize]="pageSize" [skip]="skip"
      [pageable]="{buttonCount: 5, pageSizes: [10, 25, 50]}" style="height: 51vh;" class="mt-1" *ngIf="!loading">
      <ng-container *ngIf="dataGrid.length !== 0">
        <kendo-grid-column field="exten" title="Ext." width="80" class="text-right"></kendo-grid-column>
        <kendo-grid-column field="Descripcion" title="Descripción" width="200"></kendo-grid-column>
        <kendo-grid-column field="Grupo" title="Grupo" width="80" class="text-right"></kendo-grid-column>
        <kendo-grid-column field="Depto" title="Depto." width="80" class="text-right"></kendo-grid-column>
        <kendo-grid-column field="cuarto" title="Cuarto" width="80" class="text-right"></kendo-grid-column>
        <kendo-grid-column field="NoFolio" title="#Folio" width="80" class="text-right"></kendo-grid-column>
        <kendo-grid-column field="Tipo" title="Tipo" width="80"></kendo-grid-column>
        <kendo-grid-column field="Desviacion" title="Desvío" width="80" class="text-right"></kendo-grid-column>
      </ng-container>
      <ng-template kendoGridNoRecordsTemplate>
        {{ noRecords }}
      </ng-template>
    </kendo-grid>
  </div>
  <app-loading *ngIf="loading">Buscando resultados...</app-loading>
</div>

<ng-template #modal let-modal let-c="close">
  <div class="modal-header">
    <h6 class="modal-title" id="modal-graf">{{ modalTitle }}</h6>
    <button class="close" aria-label="Close" (click)="modal.dismiss('Cross click')">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body">

    <app-help-telefonos-grupos (telefonosGrupos)="getDataModal($event, 'telefonosGrupos'); c();"
      *ngIf="modalType === 'telefonosGrupos'">
    </app-help-telefonos-grupos>
    <app-help-telefonos-departamentos (telefonosDepto)="getDataModal($event, 'telefonosDepto'); c();"
      *ngIf="modalType === 'telefonosDepto'">
    </app-help-telefonos-departamentos>
    <app-all-cuartos (allCrts)="getDataModal($event, 'allCrts'); c();" *ngIf="modalType === 'allCrts'">
    </app-all-cuartos>
    <app-help-telefonos-tipo-tarifa (telefonosTTarifa)="getDataModal($event, 'telefonosTTarifa'); c();"
      *ngIf="modalType === 'telefonosTTarifa'">
    </app-help-telefonos-tipo-tarifa>
    <app-help-telefonos-extensiones (telefonosExt)="getDataModal($event, 'telefonosExt'); c();"
      *ngIf="modalType === 'telefonosExt'">
    </app-help-telefonos-extensiones>

  </div>
  <div class="modal-footer">
    <button class="btn btn-secondary" (click)="c('Close click')">Cerrar</button>
  </div>
</ng-template>
